<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Tutorial: webclients</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Tutorial: webclients</h1>

    <section>

<header>
    

    <h2>webclients</h2>
</header>

<article>
    <div id="dispatch3d">     
    <h4>The getRequest - root path </h4>
    <p>By calling the node.js host url with the root path the html file of the view gets loaded<br><br>
      Follow the link to find out more about loading the function selection view and starting the 
      client side javascript.
    <br><a href="module-a_index_server.html#~router_get_d">http get request on root : load function selection view</a></p>

    <h4>Input forms and post requests</h4>
    <p id="post_reqs">      
      <p id="post_reqs_graph" style="font-weight: bold">Activate graphical editor</p>
      <img src="SwitchToGraphEdit.png" /> <br><br>  
      &ltbody&gt
      <br>&nbsp;&nbsp;&ltform action="/submit" method="POST"&gt        
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltinput class="editortype" type="text" name="editor" value="map"&gt 
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltinput class="submitbutton" type="submit" value="switch to graphical editor"&gt
      <br>&nbsp;&nbsp;&lt/form&gt  
      <br>&lt/body&gt
      <br>
      <br>      
      <a href="module-a_index_server.html#~router_post_sbm">Server reaction on clicking the submit button 'switch to graphical view'</a>
      <br><img src="RawData3dMap.png" /> <br><br>  
      <br><img src="PostgresData3dMap.png" /> <br><br>  
      <br><img src="RawData2dSetOfCurves.png" /> <br><br>  
      <br><img src="PostgresCurvesData.png" /> <br><br>  
      <a href="module-a_index_server.html#~router_post_sbm">Client side should the server redirect to 3d map graphical view</a>
      <p id="post_reqs_table" style="font-weight: bold">Create empty table</p>            
      &lttable class="table" id="table" &gt &lt/table&gt
      <br>
      <br> The empty table is filled by the currently activated data
      <br>
      <p id="post_reqs_signals" style="font-weight: bold">Activate signal view</p>            
      <img src="SwitchToSignalView.png" /> <br><br>  
      &ltbody &gt
      <br>&nbsp;&nbsp; &ltform action="/signals" method="POST"&gt   
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltinput class="signalbutton" type="submit" value="switch to signal view"&gt   
      <br>&nbsp;&nbsp; &lt/form&gt
      <br> &lt/body&gt
      <br>
      <br>
      <a href="module-a_index_server.html#~router_post_sig">Server reaction on clicking the submit button</a>
      <p id="post_reqs_staticA" style="font-weight: bold">Activate static code analysis view</p>   
      <img src="SwitchToStaticAnView.png"/> <br><br>           
      &ltbody&gt      
      <br>&nbsp;&nbsp; &ltform action="/staticcode" method="POST"&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp; &ltinput class="staticcode" type="submit" value="switch to static code analysis"&gt    
      <br>&nbsp;&nbsp; &lt/form&gt
      <br> &lt/body&gt            
      <br>
      <br>      
      <h4>Mouse clicks and pushbuttons and socket events</h4>
      <a href="module-a_index_server.html#~router_post_stc">Server reaction on clicking the submit button</a>
      <p id="socket_reqs_cal" style="font-weight: bold">Select engine configuration data</p>   
      <br><img src="CalDataFrame.png"/> <br>
      <br>&ltdiv class="configData"&gt            
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="engine"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>Engine Data&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="compressor"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>CompressorData&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="turbine"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>VNT Data&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="exhaust"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>Exhaust Data&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="emissions"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>Emmission Data&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt    
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&ltdiv class="roadloads"&gt      
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lth3>Road loads&lt/h2&gt
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&lt/div&gt    
      <br>&lt/div&gt   
      <p id="startDispatchHtmlScript" style="font-weight: bold">Start JS to load dynamic content</p>   
      &ltscript type="text/javascript", src="node_modules/d3/dist/d3.min.js"&gt&lt/script&gt  
      <br>&ltscript type="text/javascript", src="node_modules/socket.io/client-dist/socket.io.js"&gt&lt/script&gt
      <br>&ltscript type="module", src="Script/handleModelData.js"&gt&lt/script&gt
      <br>&ltscript type="module", src="Script/createDataViz.js"&gt&lt/script&gt
      <br>&ltscript type="module"&gt
      <br>
      <br>import {handleDataset} from "./Script/handleModelData.js";
      <br>import {dataviz}       from "./Script/createDataViz.js";
      <br>
      <br>var socket = io({autoConnect: false});
      <br>if(!socket.connected)
      <br>{
        <br>socket.connect();    
        <br>}
        <br> 
      <br>dataviz(socket);
      <br>
      The code snippet above executes the following steps
      <li> include data driven documents (d3.js) framework</li>
      <li> include socket.io framework for fast client<->server communication</li>
      <li> load mouse click event handler as a module (handleModelData.js)</li>
      <li> load visualization (pushbuttons, tables) (createDataViz.js)</li>
      <li> import function 'handleDataset' from mouse click event module</li>
      <li> import function 'dataviz' from data visuzalization module</li>
      <li> create a socket.io object which has to be explicitly connected</li>
      <li> connect the socket object if it is not.</li>
    </p>
    <p>      
      <p id="ConnectToSocket" style="font-weight: bold">Load initial data on socket connection</p>         
      <b>Step 1 : create methods and objects from module files (construction but no call)</b>
      <br> This code section only provides methods and objects but the function calls happen event based.
      All events are socket.io communication events.<br> Provided modules and objects are:<br>
      <li>getWav : get amplitude time stimulation files from linux file system</li>
      <li>io : socket.io object</li>
      <li>pg :get postgres data table and send it to the webclient via a socket.io event</li>
      <li>pgDel : delete postgres data table</li>
      <li>pgSet : set the values of a postgres data table</li>
      <li>io.on('connection',cb) : attaches a callback function 'cb' to the io object which get active on 
        socket connection.
      </li>
      <br>
      Find the details in the link : 
      <br><a href="c_socketCom_server.c_1_socketfunction.html">high level server sided module creates getter and setter functions for the postgres database and audio files and links the socket connection callback function to the socket object</a>           
      <br><br><b>Step 2 : calls and creations on socket connect</b>
      <p>On the socket connection event the following functions are called<br> 
        <li>setInterval(1000,callback(socket)) : Initiates a callback each 1000ms. The callback uses a socket.io emit event to send a timestamp to the web client.</li>
        <li>pg(socket, ThermoBaseDataStationary, thermdata) : gets the postgres table 'ThermoBaseDataStationary' and sends it to the webclient by emitting the 'thermdata' event.</li>
      </p>
      <p>On the socket connection the following event handlers created (but not called). The call happens on socket.io event receiption.<br> 
        <li>disconnect : on socket disconnect - prints the disconnected status on the console on a socket.io disconnect (typ. after a communication timeout)</li>        
        <li>initNewData : on click of compressor or turbine or road loads pushbutton - initializes a new set of compressor or turbine curves</li>
        <li>curvedata : on read cycle event created by a read loop started by initNewData - writes the set of curve to postgres</li>
        <li>getCurve : on 2d graph generation - emitted by the 2d curve editor view which uses the curvedata which has to be created first</li>        
        <li>tabledata : on click of the map structured data behind a corresponding push button</li>
        <li>getTable : on 3d map generation - emitted by the 3d map editor view which uses the tabledata which has to be created first</li>
        <li>getAudioFlPths : on signal view generation - emitted by the simulation view : get all stimulation file paths</li>                
      </p>
      <a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">server sided callback on connection</a>           
      <br><br><b>Step 3 : Client reacte on step 2 thermdata event - receipt of all engine thermodynamic data</b>
      <br><br><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">Callback thermodynamic data</a>     
      <br><br><b>Step 4 : Create pushbuttons for engine data objects</b>
      <br><img src="EngDataPushbuttons.png" /><br>    
      <br><br><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html#.forAllObjectinPostgresDataset">Creating pushbuttons from engine configuration data</a>    
      <br><br><b>Event 1 : Mouse click on engine data related pushbutton</b>      
      <br><br><a href="data.d_1_handler.html">Callback : click on engine configuration data push buttons</a>    
    </p>   
    <h4>Function Selector - select engine model processing function</h4>
    <img src="DispatcherView_3dMap.png" /> <br>
    <p>
      Once the html file is received by the web client the client side javascript starts by creating a socket.io object. 
      If the socket is not yet connected a connection is requested by the web client and the server reacts on the connecion event. 
      <li>start periodic time event to synchronize time dependent engine model simulations</li>
      <li>send thermodynamic data by emiting a socket io event together with the data</li>      
      <br>Follow the link to find more about the server sided event handling : 
      <br><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">Link on connection event callback on server</a>      
    </p> 
    <br><a href="data.d_1_handler.html">Link on engine data pushbutton event callback on server</a>
    <br><a href="module-a_index_server.html#~router_post">Link on http post service on selection of the signals view</a>
    <br><a href="module-a_index_server.html#~router_post">Link on http post service on selection of graphical editor</a>        
</div>
<div id="dispatch_2dCurve">     
    <h4>Set of constants</h4>
    <img src="dispatch_2dCurve.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
    <br><a href="module-a_index_server.html#~router_post">Link on redirection on curve editor</a>    
</div>
<div id="dispatchConsts">     
    <h4>Set of constants</h4>
    <img src="DispatcherView_Constants.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
</div>
<div id="editCurve">     
    <h4>Set of constants</h4>
    <img src="CurveView_compressor.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
    <br><a href="module-a_index_server.html#~router_post">Link on 2d curve editor view</a>    
</div>
<div id="editMap">     
    <h4>Set of constants</h4>
    <img src="CurveView_efficiency.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
</div>
<div id="editMap">     
    <h4>Set of constants</h4>
    <img src="CurveView_efficiency.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
</div>
<div id="visStatAnalysis">     
    <h4>Set of constants</h4>
    <img src="StatAnalysView.png" />    
    <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
      the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
    </p> 
</div>
  
</article>

</section>

</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>